
package MySubst;

sub new {

    my $that  = shift;
	my $class = ref($that) || $that;
	
	my $self = { begin=>'%%', end=>'%%'};
	bless $self, $class;
	$self->delims(@_) if @_;

    return $self;
}

sub delims {
	my $self = shift;
	if ($_[0]) {
		$$self{begin} = $_[0];
		$$self{end} = ( $_[1] ? $_[1] : $_[0] );
	}
	return ($$self{begin}, $$self{end});
}

sub subst {
	my $self = shift;

	my($input,$tbl) = @_;
	my @table = %$tbl;
	my($b_delim,$e_delim) = ( $$self{begin}, $$self{end} );
	for (my $i=0; $i<@table; $i+=2) {
		my($sym,$val) = ($table[$i], $table[$i+1]);
		$input =~ s/\Q$b_delim\E(\Q$sym\E)\Q$e_delim\E/$val/ge;
	}
	return $input;
}

1;
